diff --git a/monitor.c b/monitor.c
index 0bf56e4..481eab2 100644
--- a/monitor.c
+++ b/monitor.c
@@ -2673,7 +2673,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the version of QEMU",
-        .user_print = do_info_version_print,
         .mhandler.info_new = qmp_query_version,
     },
     {
@@ -2681,7 +2680,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "list QMP available commands",
-        .user_print = monitor_user_noop,
         .mhandler.info_new = qmp_query_commands,
     },
     {
@@ -2689,7 +2687,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the character devices",
-        .user_print = qemu_chr_info_print,
         .mhandler.info_new = qmp_query_chardev,
     },
     {
@@ -2697,7 +2694,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the block devices",
-        .user_print = bdrv_info_print,
         .mhandler.info_new = qmp_query_block,
     },
     {
@@ -2705,7 +2701,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show block device statistics",
-        .user_print = bdrv_stats_print,
         .mhandler.info_new = qmp_query_blockstats,
     },
     {
@@ -2713,7 +2708,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show infos for each CPU",
-        .user_print = monitor_print_cpus,
         .mhandler.info_new = qmp_query_cpus,
     },
     {
@@ -2721,7 +2715,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show PCI info",
-        .user_print = do_pci_info_print,
         .mhandler.info_new = qmp_query_pci,
     },
     {
@@ -2729,7 +2722,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show KVM information",
-        .user_print = do_info_kvm_print,
         .mhandler.info_new = qmp_query_kvm,
     },
     {
@@ -2737,7 +2729,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the current VM status (running|paused)",
-        .user_print = do_info_status_print,
         .mhandler.info_new = qmp_query_status,
     },
     {
@@ -2745,7 +2736,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show which guest mouse is receiving events",
-        .user_print = do_info_mice_print,
         .mhandler.info_new = qmp_query_mice,
     },
     {
@@ -2753,7 +2743,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the vnc server status",
-        .user_print = do_info_vnc_print,
         .mhandler.info_new = qmp_query_vnc,
     },
     {
@@ -2761,7 +2750,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the current VM name",
-        .user_print = do_info_name_print,
         .mhandler.info_new = qmp_query_name,
     },
     {
@@ -2769,7 +2757,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show the current VM UUID",
-        .user_print = do_info_uuid_print,
         .mhandler.info_new = qmp_query_uuid,
     },
     {
@@ -2777,7 +2764,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show migration status",
-        .user_print = do_info_migrate_print,
         .mhandler.info_new = qmp_query_migrate,
     },
     {
@@ -2785,7 +2771,6 @@ static const mon_cmd_t qmp_query_cmds[] = {
         .args_type  = "",
         .params     = "",
         .help       = "show balloon information",
-        .user_print = monitor_print_balloon,
         .mhandler.info_async = qmp_query_balloon,
         .flags      = MONITOR_CMD_ASYNC,
     },